<?php declare(strict_types = 1);

namespace Drupal\domain_perm;

use Drupal\Core\DependencyInjection\ContainerBuilder;
use Drupal\Core\DependencyInjection\ServiceModifierInterface;
use Symfony\Component\DependencyInjection\Definition;
use Symfony\Component\DependencyInjection\Reference;

final class DomainPermServiceProvider implements ServiceModifierInterface {

  public function alter(ContainerBuilder $container): void {

    if ($container->hasDefinition('user_permissions_hash_generator')) {
      $definition = new Definition('Drupal\Core\Cache\NullBackend', ['null']);
      $definition->setPublic(TRUE);
      $container->setDefinition('domain_perm.cache.null', $definition);

      $container->getDefinition('user_permissions_hash_generator')
        ->replaceArgument(1, new Reference('domain_perm.cache.null'));
    }
  }
}
